<?php /* -*- coding: utf-8 -*- */

/** \file uneOPiCitation_pour_Facebook.php
 * (February 6, 2014)
 *
 * \brief
 * Little PHP application to send one quotation (from OPiCitations)
 * to Facebook account https://www.facebook.com/1OPiCitationParJour
 *
 * Use the https://github.com/facebook/facebook-php-sdk library.
 *
 * Piece of OPiQuotations.
 * https://bitbucket.org/OPiMedia/opiquotations
 *
 * GPLv3 --- Copyright (C) 2014 Olivier Pirson
 * http://www.opimedia.be/
 *
 * @package OPiCitations
 */

set_include_path(get_include_path().PATH_SEPARATOR.dirname(realpath(__FILE__)));
require_once 'OPiQuotations/log.inc';

#DEBUG
if (true) {
  // Development configuration
  ini_set('display_errors', 'stdout');
  ini_set('display_startup_errors', 1);
  ini_set('html_errors', 1);

  error_reporting(-1);

  assert_options(ASSERT_ACTIVE, true);
  assert_options(ASSERT_WARNING, true);
  assert_options(ASSERT_BAIL, true);
}
else {
#DEBUG_END
  // Production configuration
  ini_set('display_errors', 'stderr');
  ini_set('display_startup_errors', 0);
  ini_set('html_errors', 0);

  error_reporting(-1);

  assert_options(ASSERT_ACTIVE, false);
  assert_options(ASSERT_WARNING, false);
  assert_options(ASSERT_BAIL, false);

  set_error_handler('\OPiQuotations\error_handler');
#DEBUG
}
#DEBUG_END

mb_internal_encoding('UTF-8');
mb_regex_encoding('UTF-8');
mb_http_output('UTF-8');
mb_detect_order('UTF-8');

require_once 'OPiQuotations/OPiQuotations.inc';


// Choose a quotation at random
$opiquotations = new OPiQuotations\OPiQuotations();

$quots = $opiquotations->quotations_by_random(1, 'Facebook - 1OPiCitationParJour');

if (empty($quots)) {
  OPiQuotations\to_log('uneOPiCitation_pour_Facebook.php: empty quots!');

  return false;
}

$text = $quots[0]->to_text_facebook('http://www.opimedia.be/OPiCitations/?id='.$quots[0]->id());


// Connect and send to Facebook
require_once('.private/Facebook_login.inc');

$ch = curl_init('https://graph.facebook.com/'.$page_id.'/feed');
if (!$ch) {
  OPiQuotations\to_log('uneOPiCitation_pour_Facebook.php curl_init error');

  return false;
}

$r = curl_setopt_array($ch,
                       array(CURLOPT_POST => 1,
                             CURLOPT_POSTFIELDS => array('access_token' => $access_token,
                                                         'message' => $text),
                             CURLOPT_RETURNTRANSFER => 1,
                             CURLOPT_SSL_VERIFYPEER => false));
if ($ch === false) {
  OPiQuotations\to_log('uneOPiCitation_pour_Facebook.php curl_setopt_array error '.curl_errno($ch).' : '.curl_error($ch));

  return false;
}

$return = curl_exec($ch);
if ($return === false) {
  OPiQuotations\to_log('uneOPiCitation_pour_Facebook.php curl_exec error '.curl_errno($ch).' : '.curl_error($ch));

  return false;
}

curl_close($ch);

$return = json_decode($return, true);

if (($return === null) || isset($return['error'])) {
  OPiQuotations\to_log('uneOPiCitation_pour_Facebook.php Facebook error '.print_r($return, true));

  return false;
}

?>